<?php

/**
* K2 Auto Archiver plugin
* @version 1.1
* @author Peter Kovacs - keepjoomla.com
* @copyright (C) Peter Kovacs, www.keepjoomla.com
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgContentK2autoarchiver extends JPlugin
{

	function plgContentK2autoarchiver( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}


	function onPrepareContent( &$article, &$params, $limitstart )
	{
		global $mainframe;
		$db =& JFactory::getDBO();		
		
		$lang = & JFactory::getLanguage();
		$lang->load('plg_content_k2autoarchiver', JPATH_ADMINISTRATOR);
		
		
		$whereA = Array();

		$plugin =& JPluginHelper::getPlugin( 'content', 'k2autoarchiver' );
		$pluginparams = new JParameter( $plugin->params );
		
		$action = $pluginparams->def('action');
		$sourcecat = trim($pluginparams->def('sourcecat'));
		$defaultcat = $pluginparams->def('defaultcat');
		$emailto = $pluginparams->def('emailto');
		
		$actionLog = Array();
		
		$whereA[] = ' (a.trash != 1) ';
		if(!empty($sourcecat)) {
			$whereA[] = ' (a.catid IN (' . $sourcecat . '))';
		}

		$where = implode(' AND ', $whereA);				
		$query .= 'SELECT * FROM #__k2_items a
						WHERE (a.publish_down > "0000-00-00 00:00:00") AND (a.publish_down < NOW()) AND
						' . $where;

		$db->setQuery($query);
		$list = $db->loadObjectList();
		
		foreach($list as $item) {
		
			switch($action) {
				case 'archive':
					$actionLog[] = JText::_('MOZGATAS_ARCHIVUMBA') . ' - ' . $item->title . ' (ID: ' . $item->id . ')';
					if(!empty($defaultcat) && is_numeric($defaultcat)) {
						$query = 'UPDATE #__k2_items SET catid='.$defaultcat.' WHERE id=' .$item->id;
						$db->setQuery($query);
						$db->query();
					} 
				break;
			
				case 'trash':
					$actionLog[] = JText::_('MOZGATAS_KUKABA') . ' - ' . $item->title . ' (ID: ' . $item->id . ')';				
					$query = 'UPDATE #__k2_items SET trash=1 WHERE id=' .$item->id;
					$db->setQuery($query);
					$db->query();					
					
				break;
				
				case 'delete':
					$actionLog[] = JText::_('VEGLEGES_TORLES') . ' - ' . $item->title . ' (ID: ' . $item->id . ')';				
				
					$query = 'DELETE FROM #__k2_items WHERE id=' .$item->id;
					$db->setQuery($query);
					$db->query();	

					$query = 'DELETE FROM #__k2_rating WHERE itemID=' .$item->id;
					$db->setQuery($query);
					$db->query();			

					$query = 'DELETE FROM #__k2_attachments WHERE itemID=' .$item->id;
					$db->setQuery($query);
					$db->query();
					
					$query = 'DELETE FROM #__k2_comments WHERE itemID=' .$item->id;
					$db->setQuery($query);
					$db->query();

					$query = 'DELETE FROM #__k2_tags_xref WHERE itemID=' .$item->id;
					$db->setQuery($query);
					$db->query();
					
				break;
			}
		}

		if( (count($actionLog) > 0)  && !empty($emailto) ) {
			$mailer =& JFactory::getMailer();
			$config =& JFactory::getConfig();
			$sender = array( 
				$config->getValue( 'config.mailfrom' ),
				$config->getValue( 'config.fromname' ) );
			 
			$mailer->setSender($sender);
			
			$recipient = explode(",", $emailto);
			
			$mailer->addRecipient($recipient);
			
			$mailer->setSubject(JText::_('ACTIONLOG_EMAIL_SUBJECT'));
			
			$body = implode('<br />', $actionLog);
			
			$mailer->setBody($body);
			
			$mailer->isHTML(true);

			$mailer->Send();
		
		}

	}
}